<?php
/*
 * last modified---
 * 	07-11-11/kbw/ various mods for using CLI to auto-pickup web payments
 * 	07-19-10/kbw/ allow for multiple Issuers
 *		09-02-09/kbw/ new
 *
 *	purpose---
 *		process submission of sci test form
 *
 *	inputs---
 *		in $_POST:
 *			buyerJID	-	JID of buyer/site visitor
 *			amount	-	amount of sale
 *			currency	-	units of amount
 *			issuer	-	Issuer type of voucher payment we're requesting
 *			baggage1	-	first sample baggage field describing order
 *			baggage2	-	second sample baggage field describing order
 *			...			etc.
 */

// parse input from form -- must have JID, amount, and currency
$buyerJID = $_POST['buyerJID'];
if (!$buyerJID || $buyerJID == '') {
	die("please enter your JID");
}
$amount = $_POST['amount'];
if (!$amount) {
	die("please enter sale amount");
}
$currency = $_POST['currency'];
if (!$currency) {
	die("please select currency denomination");
}
$issuer = $_POST['issuer'];
if (!$issuer) {
	die("please select voucher Issuer");
}

// CUSTOMIZE your own list of order-describing baggage fields here:
$bag1 = $_POST['baggage1'];
$bag2 = $_POST['baggage2'];

require_once("VoucherSCI.php");

// CUSTOMIZE for your environment as needed below
// the Jabber server where your web bot has a login
$jabber = "ofs.vm.to";
// your merchant website
$website = "https://www.voucher-safe.org";
// your merchant VS# where you receive payments
$merchantVS = "webscitest-1348@voucher-safe.org";
// the length of the encryption secret
$secretLen = 8;

// set up voucher sci interface
$vouchSCI = new VoucherSCI($website,
									$jabber,
									5233,					// <-- your Jabber server's port
									"testwebmerchant",// <-- your web bot JID username
									"4WebSCItesting",	// <-- your web bot's password
									null);
// CUSTOMIZE with the VS# where you wish to be paid for your orders
$vouchSCI->setSellerVS($merchantVS);

// pick a secret (8 chars long in this example)
$secret = $vouchSCI->pickSecret($secretLen);

// build the subject and baggage -- order Id in subject is a good idea
$orderId = mt_rand(10, 1000);
$subject = "Your order #" . $orderId . " from " . $website;

// CUSTOMIZE by building an array containing all your baggage name/value pairs
// Note: limit on the size of this array is 3.
$baggage = array('orderId' => $orderId);
if ($bag1) {
	$baggage['baggage1'] = $bag1;
}
if ($bag2) {
	$baggage['baggage2'] = $bag2;
}

// send the order data
$vouchSCI->sendOrderInfo($buyerJID,
								 $subject,
								 $amount,
								 $currency,
								 $issuer,
								 $baggage,
								 $secret);

// display results
?>
<html>
<head>
<title><?php echo($website . " order data sent"); ?></title>
</head>
<body bgcolor="cyan">
<br/><br/><br/>
<!-- your boilerplate here -->
<center>
<p>
Your order <?php echo($orderId . " "); ?>
information has been sent to: <?php echo($buyerJID); ?>
<br/>
</p>
<p>
<!-- You may use the displaySecret.php tool as below to show the decryption
	  secret graphically.  This is essential if you are not using https.
	  You may also show the plaintext, to enable copy/paste.
  -->
Your order decryption code is: <?php echo($secret);?><br/>
<img src="displaySecret.php?secret=<?php echo("$secret&digits=$secretLen");?>"
	alt="<?php echo($secret);?>"/>
</p>
<br/><br/><br/>

<!-- The user must click this button once their Voucher-Safe payment has been
	completed.  Doing so will trigger a payment pickup invocation.
-->
<form method="POST" action="scipickup.php">
<center>
Please make your Voucher-Safe payment to: <?php echo($merchantVS); ?>.<br/><br/>
To do this, in your Voucher-Safe client click on Payment and enter the
decryption code displayed above.<br/>
Your payment form will be pre-populated with the data from your website order.
<br/><br/>
When you have successfully made your payment, click on the Payment Completed
button below.<br/>
Processing can take a minute or two, so be patient.
<br/><br/><br/>
<input type="submit" name="pmtdone" value="Payment Completed"/>
</center>
<!-- you must tell the processor what baggage field to look for + its value -->
<input type="hidden" name="pmtKey" value="orderId"/>
<input type="hidden" name="keyVal" value="<?php echo($orderId);?>"/>
<!-- NB: you might also want to pass as hidden fields anything which will be
	wanted by the success and failure URLs.
-->
</form>
</body>
</html>
